unit Animacoes;

interface

uses
  System.Classes, System.UITypes, FMX.Objects, FMX.Types, FMX.Ani,
  FMX.StdCtrls, FMX.Edit;

type
  TAnimacoes = class
  private
    { private }
  public
    class procedure AnimaOpacityMouse(ARectangle: TRectangle);
    class procedure AnimaOpacityMouseReverse(ARectangle: TRectangle);
    class procedure CloseMenu(AFloat: TFloatAnimation; ARec: TRectangle); static;
    class procedure OpenMenu(AFloat: TFloatAnimation; ARec: TRectangle); static;
    class procedure LabelTitleVisible(ALabel: TLabel; AEdit: TEdit); static;
  end;

implementation

class procedure TAnimacoes.AnimaOpacityMouse(ARectangle: TRectangle);
begin
  ARectangle.AnimateFloat('Opacity', 0.4, 1, TAnimationType.&In, TInterpolationType.Linear);
end;

class procedure TAnimacoes.AnimaOpacityMouseReverse(ARectangle: TRectangle);
begin
  ARectangle.AnimateFloat('Opacity', 1, 0.4, TAnimationType.&In, TInterpolationType.Linear);
end;

class procedure TAnimacoes.CloseMenu(AFloat: TFloatAnimation; ARec: TRectangle);
begin
  AFloat.Inverse := true;
  AFloat.Start;
  ARec.AnimateFloat('Opacity', 0, 0.4);
  ARec.Tag := 0; // Menu fechado
end;

class procedure TAnimacoes.OpenMenu(AFloat: TFloatAnimation; ARec: TRectangle);
begin
  AFloat.Inverse := false;
  AFloat.Start;
  ARec.AnimateFloat('Opacity', 1, 0.4);
  ARec.Tag := 1; // Menu aberto
end;

class procedure TAnimacoes.LabelTitleVisible(ALabel: TLabel; AEdit: TEdit);
begin
  if AEdit.Text <> '' then
    ALabel.Visible := true
  else
    ALabel.Visible := false;
end;

end.
