unit Model.Estabelecimento;

interface

uses
  System.Classes, System.SysUtils, Generics.Collections,
  Entidade.Base_Nuvem_Usuario, Model.Conexao;

type
  TModelEstabelecimento = class
  private
    FEstabelecimento: TEstabelecimento;
    FFantasia: string;
    FIm: string;
    FCnpjcpf: string;
    FIe: string;
    FClasse: Integer;
    FRazao: string;
    function GetGrupoEstabelecimento(const ANameGrupo: string): TGrupoEstabelecimento;
    function GetConexao: TList<TConexao>;
  public
    function SaveOrUpdate(isUpdate: boolean): TEstabelecimento;
    property Estabelecimento: TEstabelecimento read FEstabelecimento write FEstabelecimento;
    property Razao: string read FRazao write FRazao;
    property Fantasia: string read FFantasia write FFantasia;
    property Classe: Integer read FClasse write FClasse;
    property Cnpjcpf: string read FCnpjcpf write FCnpjcpf;
    property Ie: string read FIe write FIe;
    property Im: string read FIm write FIm;
  end;

implementation

{ TModelEstabelecimento }

const
  url: string = 'http://localhost:2550/v1/service';

function TModelEstabelecimento.GetConexao: TList<TConexao>;
var
  Conexao: TConexao;
begin
  result := TList<TConexao>.Create;
  Conexao := TConexao.Create;

  Conexao.url := url;

  result.Add(Conexao);
end;

function TModelEstabelecimento.GetGrupoEstabelecimento(const ANameGrupo: string): TGrupoEstabelecimento;
var
  GrupoEstab: TGrupoEstabelecimento;
begin
  GrupoEstab := TGrupoEstabelecimento.Create;

  GrupoEstab.Descricao := ANameGrupo;

  TModelConexao.ObterInstanciaUsuario().Post(GrupoEstab);

  result := GrupoEstab;
end;

function TModelEstabelecimento.SaveOrUpdate(isUpdate: boolean): TEstabelecimento;
begin
  if not isUpdate then
  begin
    if Assigned(FEstabelecimento) then
      FreeAndNil(FEstabelecimento);

    FEstabelecimento := TEstabelecimento.Create;
    FEstabelecimento.FkGrupoEstabelecimento := GetGrupoEstabelecimento('Grupo: ' + Self.Razao);
  end;

  with FEstabelecimento do
  begin
    Razao := Self.Razao;
    Fantasia := Self.Fantasia;
    Classe := Self.Classe;
    Cnpjcpf := Self.Cnpjcpf;
    Ie := Self.Ie;
    Im := Self.Im;
  end;

  if isUpdate then
    TModelConexao.ObterInstanciaUsuario().Put(FEstabelecimento)
  else
    TModelConexao.ObterInstanciaUsuario().Post(FEstabelecimento);

  if Assigned(FEstabelecimento) then
    result := FEstabelecimento;
end;

end.
