unit Model.Usuario.Listas;

interface

uses
  System.Classes, System.SysUtils, Generics.Collections,
  Entidade.Base_Nuvem_Usuario,
  Model.Conexao;

type
  TTypeUsuario = (tpUsuario = 1, tpCliente = 2, tpFuncionario = 3, tpFornecedor = 4);

  TModelUsuarioListas = class
  private
    FUsuario: TUsuario;
    FListaEndereco: TList<TEndereco>;
    FListaTelefone: TList<TTelefone>;
    FListaEmail: TList<TEmail>;
    FListaIdentificador: TList<TTypeUsuario>;
    FListaConexao: TList<TConexao>;
    procedure SetSaveListaIdentificador(const Value: TList<TTypeUsuario>);
    procedure SetSaveListaEmail(const Value: TList<TEmail>);
    procedure SetSaveListaTelefone(const Value: TList<TTelefone>);
    procedure SetSaveListaEndereco(const Value: TList<TEndereco>);
    procedure SetSaveListaConexao(const Value: TList<TConexao>);
  public
    property Usuario: TUsuario read FUsuario write FUsuario;
    property SaveListaEmail: TList<TEmail> read FListaEmail write SetSaveListaEmail;
    property SaveListaTelefone: TList<TTelefone> read FListaTelefone write SetSaveListaTelefone;
    property SaveListaEndereco: TList<TEndereco> read FListaEndereco write SetSaveListaEndereco;
    property SaveListaConexao: TList<TConexao> read FListaConexao write SetSaveListaConexao;
    property SaveListaIdentificador: TList<TTypeUsuario> read FListaIdentificador write SetSaveListaIdentificador;
  end;

implementation

procedure TModelUsuarioListas.SetSaveListaConexao(const Value: TList<TConexao>);
var
  i: Integer;
begin
  FListaConexao := Value;

  for i := 0 to FListaConexao.Count - 1 do
  begin
    FListaConexao[i].FkUsuario := FUsuario;
    TModelConexao.ObterInstanciaUsuario().Post(FListaConexao[i]);
  end;
end;

procedure TModelUsuarioListas.SetSaveListaEmail(const Value: TList<TEmail>);
var
  i: Integer;
begin
  FListaEmail := Value;

  for i := 0 to FListaEmail.Count - 1 do
  begin
    FListaEmail[i].FkUsuario := FUsuario;
    TModelConexao.ObterInstanciaUsuario().Post(FListaEmail[i]);
  end;
end;

procedure TModelUsuarioListas.SetSaveListaTelefone(const Value: TList<TTelefone>);
var
  i: Integer;
begin
  FListaTelefone := Value;

  for i := 0 to FListaTelefone.Count - 1 do
  begin
    FListaTelefone[i].FkUsuario := FUsuario;
    TModelConexao.ObterInstanciaUsuario().Post(FListaTelefone[i]);
  end;
end;

procedure TModelUsuarioListas.SetSaveListaEndereco(const Value: TList<TEndereco>);
var
  i: Integer;
  Endereco: TEndereco;
begin
  FListaEndereco := Value;

  for i := 0 to FListaEndereco.Count - 1 do
  begin
    Endereco.FkUsuario := FUsuario;
    TModelConexao.ObterInstanciaUsuario().Post(Endereco);
  end;
end;

procedure TModelUsuarioListas.SetSaveListaIdentificador(const Value: TList<TTypeUsuario>);
var
  i: Integer;
  x: TTypeUsuario;
  IdentificadorUsuario: TIdentificador;
begin
  FListaIdentificador := Value;

  for x := Low(TTypeUsuario) to High(TTypeUsuario) do
  begin
    for i := 0 to FListaIdentificador.Count - 1 do
      if TTypeUsuario(FListaIdentificador[i]) = x then
      begin
        IdentificadorUsuario := TIdentificador.Create;

        IdentificadorUsuario.Identificador := Integer(x);
        IdentificadorUsuario.FkUsuario := FUsuario;

        TModelConexao.ObterInstanciaUsuario().Post(IdentificadorUsuario);
      end;
  end;
end;

end.
