unit Model.Usuario;

interface

uses
  System.Classes, System.SysUtils, Generics.Collections,
  Entidade.Base_Nuvem_Usuario,
  Model.Conexao;

type
  TModelUsuario = class
  private
    FToken: TToken;
    FUsuario: TUsuario;
    FCodigoUsuario: string;
    FNomeUsuario: string;
    FSenhaUsuario: string;
  public
    function SaveOrUpdate(isUpdate: Boolean): TUsuario;
    function GetListaCliente: TList<TUsuario>;
    property Usuario: TUsuario read FUsuario write FUsuario;
    property Token: TToken read FToken write FToken;
    property CodigoUsuario: string read FCodigoUsuario write FCodigoUsuario;
    property NomeUsuario: string read FNomeUsuario write FNomeUsuario;
    property SenhaUsuario: string read FSenhaUsuario write FSenhaUsuario;
  end;

implementation

{ TModelUsuario }

function TModelUsuario.GetListaCliente: TList<TUsuario>;
begin
  //  Result := TModelConexao.ObterInstanciaUsuario(). //
  //    Service<IUsuarioService>.GetListaCliente(FToken);
end;

function TModelUsuario.SaveOrUpdate(isUpdate: Boolean): TUsuario;
begin
  if not isUpdate then
  begin
    if Assigned(FUsuario) then
      FreeAndNil(FUsuario);

    FUsuario := TUsuario.Create;
  end;

  with FUsuario do
  begin
    Codigo := FCodigoUsuario;
    NomeRazao := FNomeUsuario;
    Senha := FSenhaUsuario;
  end;

  if isUpdate then
    TModelConexao.ObterInstanciaUsuario().Put(FUsuario)
  else
    TModelConexao.ObterInstanciaUsuario().Post(FUsuario);

  //  FUsuario := TModelConexao.ObterInstanciaUsuario().Get<TUsuario, TGUID>(FUsuario.IdUsuario);

  if Assigned(FUsuario) then
    Result := FUsuario;
end;

end.
