unit View.Principal;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.Edit, FMX.ComboEdit, FMX.ListBox, FMX.Controls.Presentation, FMX.Layouts,
  FMX.Objects, Generics.Collections,
  Entidade.Base_Nuvem_Usuario,
  Model.Conexao,
  Model.Usuario,
  Model.Usuario.Listas,
  Model.Token,
  Model.Estabelecimento,
  Animacoes;

type
  TviewPrincipal = class(TForm)
    lytPrincipal: TLayout;
    rtgFundo: TRectangle;
    gplButtons: TGridPanelLayout;
    lytNovo: TLayout;
    rtgNovo: TRectangle;
    lblNovo: TLabel;
    lytGravar: TLayout;
    rtgGravar: TRectangle;
    lblGravar: TLabel;
    lytProcurar: TLayout;
    rtgProcurar: TRectangle;
    lblProcurar: TLabel;
    lytExcluir: TLayout;
    rtgExcluir: TRectangle;
    lblExcluir: TLabel;
    lytDados: TLayout;
    lyt_03: TLayout;
    lyt_Fantasia: TLayout;
    edt_nomefantasia: TEdit;
    lbl_nomeFantasia: TLabel;
    lyt_Razao: TLayout;
    edt_razaoSocial: TEdit;
    lblrazaoSocial: TLabel;
    lyt_01: TLayout;
    lyt_Usuario: TLayout;
    edt_Email_Usuario: TEdit;
    lbl_Usuario: TLabel;
    lyt_Senha: TLayout;
    edt_Senha_Usuario: TEdit;
    lbl_Senha: TLabel;
    lyt_04: TLayout;
    layout_cnpj: TLayout;
    lbl_Cnpj: TLabel;
    edt_cnpjcpf: TEdit;
    layout_ie: TLayout;
    lbl_Ie: TLabel;
    edt_ie: TEdit;
    layout_inscricao_municipal: TLayout;
    lbl_inscricao_municipal: TLabel;
    edt_inscricao_municipal: TEdit;
    lyt_classe: TLayout;
    lbl_classe: TLabel;
    cbb_classe: TComboBox;
    lyt_07: TLayout;
    lyt_cidade: TLayout;
    edt_cidade: TEdit;
    lbl_cidade: TLabel;
    lyt_uf: TLayout;
    lbl_uf: TLabel;
    cbb_uf: TComboEdit;
    lyt_referencia: TLayout;
    edt_referencia: TEdit;
    lbl_referencia: TLabel;
    lyt_08: TLayout;
    lyt_Tel01: TLayout;
    lbl_Tel01: TLabel;
    edt_Tel01: TEdit;
    lyt_ddd: TLayout;
    edt_ddd: TEdit;
    lbl_Ddd: TLabel;
    lyt_02: TLayout;
    lyt_Nome_User: TLayout;
    edt_Nome_Usuario: TEdit;
    lbl_NomeUsuario: TLabel;
    lyt_guid_invisivel: TLayout;
    edt_id: TEdit;
    lyt_05: TLayout;
    layout_logradouro: TLayout;
    lb_logradouro: TLabel;
    edt_logradouro: TEdit;
    Layout_cep: TLayout;
    lbl_cep: TLabel;
    edt_Cep: TEdit;
    btn_FormataCep: TEditButton;
    layout_numero: TLayout;
    lb_numero: TLabel;
    edt_numero: TEdit;
    lyt_06: TLayout;
    layout_complemento: TLayout;
    lblComplemento: TLabel;
    edt_complemento: TEdit;
    layout_bairro: TLayout;
    lblBairro: TLabel;
    edt_bairro: TEdit;
    lyt_bloco: TLayout;
    lbl_bloco: TLabel;
    edt_bloco: TEdit;
    procedure rtgGravarClick(Sender: TObject);
    procedure rtgNovoMouseEnter(Sender: TObject);
    procedure rtgNovoMouseLeave(Sender: TObject);
  private
    FUsuario: TUsuario;
    FEstabelecimento: TEstabelecimento;
    function GetEmail: TList<TEmail>;
    function GetEndereco: TList<TEndereco>;
    function GetIdentificador: TList<TTypeUsuario>;
    function GetTelefone: TList<TTelefone>;
    function GetUriConexao: TList<TConexao>;
    procedure MontaObjEstabelecimento(AModelEstabelecimento: TModelEstabelecimento);
    procedure SaveOrUpdate(isUpdate: Boolean);
  public
    { Public declarations }
  end;

var
  viewPrincipal: TviewPrincipal;

implementation

{$R *.fmx}

const
  UrlConexao: string = 'http://localhost:2550/v1/service';

function TviewPrincipal.GetEndereco: TList<TEndereco>;
var
  Endereco: TEndereco;
begin
  Result := TList<TEndereco>.Create;
  Endereco := TEndereco.Create;

  with Endereco do
  begin
    Cep := edt_Cep.TagString;
    Logradouro := edt_logradouro.Text;
    Numero := edt_numero.Text;
    Complemento := edt_complemento.Text;
    Bairro := edt_bairro.Text;
    Cidade := edt_cidade.Text;
    Uf := cbb_uf.Text;
    Referencia := edt_referencia.Text;
    FkUsuario := FUsuario;
  end;

  Result.Add(Endereco);
end;

function TviewPrincipal.GetEmail: TList<TEmail>;
var
  Email: TEmail;
begin
  Result := TList<TEmail>.Create;
  Email := TEmail.Create;

  with Email do
  begin
    Email := edt_Email_Usuario.Text;
    Identificador := 1;
    FkUsuario := FUsuario;
  end;

  Result.Add(Email);
end;

function TviewPrincipal.GetTelefone: TList<TTelefone>;
var
  Telefone: TTelefone;
begin
  Result := TList<TTelefone>.Create;
  Telefone := TTelefone.Create;

  with Telefone do
  begin
    CodPais := '+55';
    Ddd := edt_ddd.Text;
    Telefone := edt_Tel01.Text;
    Identificador := 1;
  end;

  Result.Add(Telefone);
end;

function TviewPrincipal.GetUriConexao: TList<TConexao>;
var
  Conexao: TConexao;
begin
  Result := TList<TConexao>.Create;
  Conexao := TConexao.Create;

  Conexao.Url := UrlConexao;

  Result.Add(Conexao);
end;

function TviewPrincipal.GetIdentificador: TList<TTypeUsuario>;
begin
  Result := TList<TTypeUsuario>.Create;

  Result.Add(tpUsuario);
  Result.Add(tpFuncionario);
end;

procedure TviewPrincipal.MontaObjEstabelecimento(AModelEstabelecimento: TModelEstabelecimento);
begin
  with AModelEstabelecimento do
  begin
    Razao := edt_razaoSocial.Text;
    Fantasia := edt_nomefantasia.Text;
    Classe := cbb_classe.ItemIndex;
    Cnpjcpf := edt_cnpjcpf.TagString;
    Ie := edt_ie.Text;
    Im := edt_inscricao_municipal.Text;
  end;
end;

procedure TviewPrincipal.rtgGravarClick(Sender: TObject);
begin
  if Assigned(FEstabelecimento) then
    SaveOrUpdate(True)
  else
    SaveOrUpdate(False);
end;

procedure TviewPrincipal.rtgNovoMouseEnter(Sender: TObject);
begin
  if Sender is TRectangle then
    TAnimacoes.AnimaOpacityMouse(TRectangle(Sender));
end;

procedure TviewPrincipal.rtgNovoMouseLeave(Sender: TObject);
begin
  if Sender is TRectangle then
    TAnimacoes.AnimaOpacityMouseReverse(TRectangle(Sender));
end;

procedure TviewPrincipal.SaveOrUpdate(isUpdate: Boolean);
var
  Token: TToken;
  ModelToken: TModelToken;
  ModelUsuario: TModelUsuario;
  ModelEstabelecimento: TModelEstabelecimento;
  ModelUsuarioLista: TModelUsuarioListas;
  i: integer;
begin
  ModelEstabelecimento := TModelEstabelecimento.Create;
  MontaObjEstabelecimento(ModelEstabelecimento);

  if isUpdate then
    ModelEstabelecimento.Estabelecimento := FEstabelecimento;

  FEstabelecimento := ModelEstabelecimento.SaveOrUpdate(isUpdate);

  //  if FPrimeiroCadastro then
  //  begin
  ModelUsuario := TModelUsuario.Create;
  ModelToken := TModelToken.Create;

  // Usuario
  with ModelUsuario do
  begin
    CodigoUsuario := '1';
    NomeUsuario := edt_Nome_Usuario.Text;
    SenhaUsuario := edt_Senha_Usuario.Text;
  end;

  FUsuario := ModelUsuario.SaveOrUpdate(isUpdate);

  ModelUsuarioLista := TModelUsuarioListas.Create;
  ModelUsuarioLista.Usuario := FUsuario;

  with ModelUsuarioLista do
  begin
    SaveListaEmail := GetEmail;
    SaveListaTelefone := GetTelefone;
    SaveListaEndereco := GetEndereco;
    SaveListaConexao := GetUriConexao;
    SaveListaIdentificador := GetIdentificador;
  end;

  // Token
  ModelToken.Estabelecimento := FEstabelecimento;
  ModelToken.Usuario := FUsuario;

  Token := ModelToken.SaveToken;
  //  end;

  ShowMessage('Operao realziada com sucesso!');
end;

end.
